<script setup lang="ts">
import GfFilter from '@/components/organisms/GfFilter.vue'
import GfList from '@/components/organisms/GfList.vue'
import { computed, ref, toRefs, watch } from 'vue'
import type { APIResult, FilterValues, Record } from '@/types'
import { useFetch } from '@/composables/fetch'
import Gfpagination from '@/components/molecules/GfPagination.vue'

const url = computed(() => {
  let url = import.meta.env.VITE_API_SEARCH_URL
  url += `dataset=${import.meta.env.VITE_API_DATASET}`
  url += '&timezone=Europe/Brussels'
  url += '&sort=-startdate'
  return encodeURI(url)
})
const {isLoading, result, error} = useFetch<APIResult>(url, {
  headers: {
    Authorization: `Apikey ${import.meta.env.VITE_API_KEY}`
  }
})
const records = computed<Record[]>(() => result.value?.records || [])
</script>

<template>
  <header>
    <h1>Gentse Feesten</h1>
  </header>
  <main>
    <section>
      <h2 class="visually-hidden">Filter</h2>
<!--      <GfFilter v-model="filter" />-->
    </section>
    <section class="relative">
      <h2 class="visually-hidden">Resultaten</h2>
      <GfList v-if="records?.length" :records="records" />
      <p v-else-if="error" class="error">Geen resultaten gevonden...<br />(● ︵ ●)</p>
      <Transition>
        <div class="loading" v-show="isLoading">
          <span>...loading</span>
        </div>
      </Transition>
<!--      <Gfpagination v-model:start="start" :nhits="nhits" :rows></Gfpagination>-->
    </section>
  </main>
</template>

<style scoped>
.relative {
  position: relative;
}
.loading {
  position: absolute;
  inset: -1rem;
  display: flex;
  align-items: center;
  justify-content: center;
  background-color: rgba(0 0 0 /0.01);
  backdrop-filter: blur(2px);
}
.v-enter-active,
.v-leave-active {
  transition: opacity 0.3s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}

</style>
